// bt.h

/*
* Copyright (c) 1994 G. David Kuhlman.
* All rights reserved.
*
* Permission is hereby granted, without written agreement and without
* license or royalty fees, to use, copy, modify, and distribute this
* software and its documentation for any purpose, provided that the
* above copyright notice and the following two paragraphs appear in
* all copies of this software.
* 
* IN NO EVENT SHALL G. DAVID KUHLMAN BE LIABLE TO ANY PARTY FOR
* DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
* OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF G. DAVID KUHLMAN
* HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* G. DAVID KUHLMAN SPECIFICALLY DISCLAIMS ANY WARRANTIES,
* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
* AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
* ON AN "AS IS" BASIS, AND G. DAVID KUHLMAN HAS NO OBLIGATION TO
* PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*/

#ifndef bt_H
#define bt_H

#ifdef __cplusplus
extern "C" {
#endif

#define SF_INTERNAL
#include "btgconst.h"
#include "btreev33.he"
#include "flen3.he"
#include "flen3.e"
#include "vlen3.he"
#include "vlen3.e"
#include "wtf.he"

#ifdef SF_DEBUG
#include "vlen3.em"
#endif

#ifdef __cplusplus
}
#endif

#include <mdlsyn.hpp>
#include <mdl.hpp>

Mdl::ErrStat btInitialize(void);
Mdl::ErrStat btTerminate(void);
Boolean btCreateDb( char *name );
Boolean btOpenDb( char *name );
void btCloseDb(void);
Db::RecNumber btAddRec( void *pBuf, short size );
Db::RecNumber btWriteRec( Db::RecNumber recno, void *pBuf, short size );
Boolean btReadRec( Db::RecNumber recno, void *pBuf );
Boolean btDeleteRec( Db::RecNumber recno );
Db::RecNumber btFirstKey( char *key );
Db::RecNumber btNextKey( char *key );
Db::RecNumber btSearchKey( char *key );
Boolean btAddKey( char *key, Db::RecNumber recno );
Boolean btDeleteKey( char *key );

#endif // bt_H

