# Send comments to:
#   Dave Kuhlman
#   Reify
#   426 Madison Ave #9
#   Redwood City, CA 94061
#   415-368-8450
#   Internet: dkuhlman@netcom.com
#
# Copyright (c) 1994 G. David Kuhlman.
# All rights reserved.
#
# Permission is hereby granted, without written agreement and without
# license or royalty fees, to use, copy, modify, and distribute this
# software and its documentation for any purpose, provided that the
# above copyright notice and the following two paragraphs appear in
# all copies of this software.
#
# IN NO EVENT SHALL G. DAVID KUHLMAN BE LIABLE TO ANY PARTY FOR
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
# OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF G. DAVID KUHLMAN
# HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# G. DAVID KUHLMAN SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
# ON AN "AS IS" BASIS, AND G. DAVID KUHLMAN HAS NO OBLIGATION TO
# PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

# .AUTODEPEND

#=============================================================
#       Translator Definitions
#=============================================================
CC = icc
CFLAGS = /c /Q /Ss /Gm /Ti /I$(INCLUDEPATH)
LIB = lib.exe
LINK = link386.exe
INCLUDEPATH = ..\h;..\db;..\sup

PCCTSFLAGS = -I..\pccts\h -D__STDC__=1

ANTLR=antlr
AFLAGS=-gt -k 2
DLG=dlg
SOR=sor
SORFLAGS=-I..\pccts\sorcerer -I..\pccts\sorcerer\support -D__STDC__=1

#=============================================================
#       Implicit Rules
#=============================================================

#=============================================================
#       List Macros
#=============================================================
.c.obj:
  $(CC) $(CFLAGS) $<

.cpp.obj:
  $(CC) $(CFLAGS) $<


LIB_DEPENDENCIES =  \
 kr.obj krg.obj scan.obj err.obj \
 krs.obj

#=============================================================
#       Explicit Rules
#=============================================================
kr.lib: kr.cfg $(LIB_DEPENDENCIES)
  - del kr.lib
  $(LIB) /quiet kr +kr.obj +krg.obj +krs.obj +scan.obj +err.obj;
  - del ..\libi\kr.lib
  move kr.lib ..\libi


#=============================================================
#       Individual File Dependencies
#=============================================================
kr.obj: kr.cfg kr.cpp kr.hpp ..\db\db.hpp

scan.obj: kr.cfg scan.c
    $(CC) $(CFLAGS) $(PCCTSFLAGS) scan.c

krg.obj: kr.cfg krg.c krg.h
    $(CC) -DSCOPE= -DINIT $(CFLAGS) $(PCCTSFLAGS) krg.c

err.obj: kr.cfg err.c krg.h
    $(CC) $(CFLAGS) $(PCCTSFLAGS) err.c

krg.c : krg.g krg.h kr.h
    $(ANTLR) $(AFLAGS) krg.g
    $(DLG) -C2 parser.dlg scan.c

krs.obj: kr.cfg krs.c krg.h
    $(CC) $(CFLAGS) $(SORFLAGS) krs.cpp

krs.c: krs.sor krg.h kr.h
    $(SOR) -funcs ANSI krs.sor
    copy krs.c krs.cpp

