/*
 * S O R C E R E R  T r a n s l a t i o n  H e a d e r
 *
 * SORCERER Developed by Terence Parr, Aaron Sawdey, & Gary Funck
 * 1992-1994
 * University of Minnesota
 * Army High Performance Computing Research Center
 * SORCERER Version 1.00B11
 */
#define SORCERER_VERSION	100B11
#define SORCERER_NONTRANSFORM
#include <stdio.h>
#include <setjmp.h>


#include <stdlib.h>
#include <fstream.h>
#include <iostream.h>

#include <db.hpp>
#include <dbblk.hpp>
#include <mdlsyn.hpp>
#include "krstrg.hpp"
#include "krstrm.hpp"
#include "kr.hpp"

// ---------------------------------------------------------

// AST struct is defined in bibl.g
#undef INCL_AST
#ifdef INCL_AST
typedef struct _ast {
	int token;                  /* required */
	struct _ast *right, *down;  /* required */
	int val;                    /* needed by this task */
} AST;
#endif // INCL_AST

// #include "charbuf.h"

#define AST_FIELDS int token, level; char * str;

#include "ast.h"

#include "sorcerer.h"
extern  Bibliography *   file_top_sor(STreeParser *_parser, AST **_root);
extern  Bibliography *   bibliography_sor(STreeParser *_parser, AST **_root);
extern  KrString *   bibliography_id_sor(STreeParser *_parser, AST **_root);
extern void bibliography_item_sor(STreeParser *_parser, AST **_root, Bibliography * pBibliography );
extern  Document *   document_sor(STreeParser *_parser, AST **_root);
extern  KrString *   document_id_sor(STreeParser *_parser, AST **_root);
extern void document_item_sor(STreeParser *_parser, AST **_root, Document * pDocument );
extern  Author *   author_super_sor(STreeParser *_parser, AST **_root);
extern  Author *   author_sor(STreeParser *_parser, AST **_root);
extern  KrString *   author_id_sor(STreeParser *_parser, AST **_root);
extern void author_item_sor(STreeParser *_parser, AST **_root, Author * pAuthor );
extern  FictionAuthor *   fictionauthor_super_sor(STreeParser *_parser, AST **_root);
extern  FictionAuthor *   fictionauthor_sor(STreeParser *_parser, AST **_root);
extern  KrString *   fictionauthor_id_sor(STreeParser *_parser, AST **_root);
extern void fictionauthor_item_sor(STreeParser *_parser, AST **_root, FictionAuthor * pFictionAuthor );
extern  HumorFictionAuthor *   humorfictionauthor_sor(STreeParser *_parser, AST **_root);
extern  KrString *   humorfictionauthor_id_sor(STreeParser *_parser, AST **_root);
extern void humorfictionauthor_item_sor(STreeParser *_parser, AST **_root, HumorFictionAuthor * pHumorFictionAuthor );
extern  RomanticFictionAuthor *   romanticfictionauthor_sor(STreeParser *_parser, AST **_root);
extern  KrString *   romanticfictionauthor_id_sor(STreeParser *_parser, AST **_root);
extern void romanticfictionauthor_item_sor(STreeParser *_parser, AST **_root, RomanticFictionAuthor * pRomanticFictionAuthor );
extern  NonfictionAuthor *   nonfictionauthor_sor(STreeParser *_parser, AST **_root);
extern  KrString *   nonfictionauthor_id_sor(STreeParser *_parser, AST **_root);
extern void nonfictionauthor_item_sor(STreeParser *_parser, AST **_root, NonfictionAuthor * pNonfictionAuthor );
extern  Pubs *   pubs_sor(STreeParser *_parser, AST **_root);
extern  KrString *   pubs_id_sor(STreeParser *_parser, AST **_root);
extern void pubs_item_sor(STreeParser *_parser, AST **_root, Pubs * pPubs );
extern  KrString *   date_sor(STreeParser *_parser, AST **_root);
extern  KrString *   location_sor(STreeParser *_parser, AST **_root);
extern  KrString *   publisher_sor(STreeParser *_parser, AST **_root);
extern  KrString *   authnotestitle_sor(STreeParser *_parser, AST **_root);
extern  KrString *   name_sor(STreeParser *_parser, AST **_root);
extern  KrString *   topicarea_sor(STreeParser *_parser, AST **_root);
extern  KrString *   period_sor(STreeParser *_parser, AST **_root);
extern  KrString *   style_sor(STreeParser *_parser, AST **_root);
extern  KrString *   docnotestitle_sor(STreeParser *_parser, AST **_root);
extern  KrString *   authorid_sor(STreeParser *_parser, AST **_root);
extern  KrString *   doctitle_sor(STreeParser *_parser, AST **_root);
extern  KrString *   bibltitle_sor(STreeParser *_parser, AST **_root);
extern  int   selecteditem_sor(STreeParser *_parser, AST **_root);
extern  int   doccount_sor(STreeParser *_parser, AST **_root);
extern  float   emotionaltemperature_sor(STreeParser *_parser, AST **_root);
extern  KrStringList *   authnotes_list_sor(STreeParser *_parser, AST **_root);
extern  DocumentList *   worksinprogress_list_sor(STreeParser *_parser, AST **_root);
extern  DocumentList *   publishedworks_list_sor(STreeParser *_parser, AST **_root);
extern  KrStringList *   biases_list_sor(STreeParser *_parser, AST **_root);
extern  KrStringList *   specialfields_list_sor(STreeParser *_parser, AST **_root);
extern  KrStringList *   docnotes_list_sor(STreeParser *_parser, AST **_root);
extern  KrStringList *   xrefs_list_sor(STreeParser *_parser, AST **_root);
extern  KrStringList *   keywords_list_sor(STreeParser *_parser, AST **_root);
extern  AuthorList *   authors_list_sor(STreeParser *_parser, AST **_root);
extern  DocumentList *   documents_list_sor(STreeParser *_parser, AST **_root);
extern  KrString *   string_sor(STreeParser *_parser, AST **_root);
extern  int   int_sor(STreeParser *_parser, AST **_root);
extern  float   float_sor(STreeParser *_parser, AST **_root);

void
#ifdef __USE_PROTOS
_refvar_inits(STreeParser *p)
#else
_refvar_inits(p)
STreeParser *p;
#endif
{
}



#include "krg.h"
#include "kr.h"

/* include support code so we don't have to link in default error routines */
#include "errsupport.c"


AST *ast_node(int token, int v)
{
AST *p = (AST *) calloc(1,sizeof(AST));
p->token = token;
// p->val = v;
return p;
} // ast_node

// --------------------------------------------------------

#ifdef __cplusplus
extern "C" {
#endif

AST * Parse(char * infilename, int show);
void deleteTree(AST *tree);

#ifdef __cplusplus
}
#endif

// --------------------------------------------------------

Bibliography * Compile(char * infilename, int show)
{
AST * root = NULL;

// ANTLR(file_top_gram(&root), InFile);

root = Parse(infilename, show);

if (root == NULL)
{
return NULL;
} // if

STreeParser parser;
STreeParserInit(&parser);
Bibliography * pBibliography;

pBibliography = file_top_sor(&parser, &root);

deleteTree(root);

return pBibliography;
} // Compile

// ---------------------------------------------------------


 Bibliography *   file_top_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 Bibliography * pRetBibliography ;
	if ( _t!=NULL && (_t->token==Tok_file_top_gram) ) {
		Bibliography * pBibliography;   
		{_SAVE;
		_MATCH(Tok_file_top_gram); _DOWN;
		 pBibliography =bibliography_sor(_parser, &_t);
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetBibliography = pBibliography;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "file_top_sor", _t);
	}
	*_root = _t;
	return pRetBibliography;
} // file_top_sor

 Bibliography *   bibliography_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 Bibliography * pRetBibliography ;
	if ( _t!=NULL && (_t->token==Tok_bibliography_gram) ) {
		Bibliography * pBibliography = new Bibliography;
		KrString * pId = NULL;
		{_SAVE;
		_MATCH(Tok_bibliography_gram); _DOWN;
		 pId =bibliography_id_sor(_parser, &_t);
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_bibltitle_gram||_t->token==Tok_authors_list_gram||
			_t->token==Tok_documents_list_gram) ) {
				bibliography_item_sor(_parser, &_t,  pBibliography );
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "bibliography_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pBibliography->Set_id(pId);
		pRetBibliography = pBibliography;
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "bibliography_sor", _t);
	}
	*_root = _t;
	return pRetBibliography;
} // bibliography_sor

 KrString *   bibliography_id_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetId ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_bibliography_id_gram) ) {
		KrString * pStr = NULL;   
		{_SAVE;
		_MATCH(Tok_bibliography_id_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		pStr = new KrString(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetId = pStr;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "bibliography_id_sor", _t);
	}
	*_root = _t;
	return pRetId;
} // bibliography_id_sor

void bibliography_item_sor(STreeParser *_parser, AST **_root, Bibliography * pBibliography )
{
	AST *_t = *_root;
	if ( _t!=NULL && (_t->token==Tok_bibltitle_gram) ) {
		KrString * pStr;   
		 pStr =bibltitle_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pBibliography->Set_bibltitle(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_documents_list_gram) ) {
		DocumentList * pList;   
		 pList =documents_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pBibliography->Set_documents(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authors_list_gram) ) {
		AuthorList * pList;   
		 pList =authors_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pBibliography->Set_authors(pList);   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "bibliography_item_sor", _t);
	}
	}
	}
	*_root = _t;
} // bibliography_item_sor

 Document *   document_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 Document * pRetDocument ;
	if ( _t!=NULL && (_t->token==Tok_document_gram) ) {
		Document * pDocument = new Document;
		KrString * pId = NULL;
		{_SAVE;
		_MATCH(Tok_document_gram); _DOWN;
		 pId =document_id_sor(_parser, &_t);
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_pubs_gram||_t->token==Tok_docnotestitle_gram||
			_t->token==Tok_authorid_gram||_t->token==Tok_doctitle_gram||_t->token==Tok_selecteditem_gram||
			_t->token==Tok_docnotes_list_gram||_t->token==Tok_xrefs_list_gram||_t->token==Tok_keywords_list_gram) ) {
				document_item_sor(_parser, &_t,  pDocument );
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "document_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pDocument->Set_id(pId);
		pRetDocument = pDocument;
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "document_sor", _t);
	}
	*_root = _t;
	return pRetDocument;
} // document_sor

 KrString *   document_id_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetId ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_document_id_gram) ) {
		KrString * pStr = NULL;   
		{_SAVE;
		_MATCH(Tok_document_id_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		pStr = new KrString(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetId = pStr;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "document_id_sor", _t);
	}
	*_root = _t;
	return pRetId;
} // document_id_sor

void document_item_sor(STreeParser *_parser, AST **_root, Document * pDocument )
{
	AST *_t = *_root;
	if ( _t!=NULL && (_t->token==Tok_selecteditem_gram) ) {
		int selectedItem;   
		 selectedItem =selecteditem_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pDocument->Set_selectedItem(selectedItem);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_doctitle_gram) ) {
		KrString * pStr;   
		 pStr =doctitle_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pDocument->Set_doctitle(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authorid_gram) ) {
		KrString * pStr;   
		 pStr =authorid_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pDocument->Set_authorid(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_pubs_gram) ) {
		Pubs * pPubs;   
		 pPubs =pubs_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pDocument->Set_pubdata(pPubs);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_keywords_list_gram) ) {
		KrStringList * pList;   
		 pList =keywords_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pDocument->Set_keywords(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_xrefs_list_gram) ) {
		KrStringList * pList;   
		 pList =xrefs_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pDocument->Set_xrefs(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_docnotes_list_gram) ) {
		KrStringList * pList;   
		 pList =docnotes_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pDocument->Set_docnotes(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_docnotestitle_gram) ) {
		KrString * pStr;   
		 pStr =docnotestitle_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pDocument->Set_docnotesTitle(pStr);   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "document_item_sor", _t);
	}
	}
	}
	}
	}
	}
	}
	}
	*_root = _t;
} // document_item_sor

 Author *   author_super_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 Author * pRetAuthor ;
	if ( _t!=NULL && (_t->token==Tok_author_gram||_t->token==Tok_fictionauthor_gram||
	_t->token==Tok_humorfictionauthor_gram||_t->token==Tok_romanticfictionauthor_gram||_t->token==Tok_nonfictionauthor_gram) ) {
		if ( _t!=NULL && (_t->token==Tok_author_gram) ) {
			Author * pAuthor;   
			 pAuthor =author_sor(_parser, &_t);
			if ( !_parser->guessing ) {
			pRetAuthor = pAuthor;   
			}
		}
		else {
		if ( _t!=NULL && (_t->token==Tok_nonfictionauthor_gram) ) {
			NonfictionAuthor * pNonfictionAuthor;   
			 pNonfictionAuthor =nonfictionauthor_sor(_parser, &_t);
			if ( !_parser->guessing ) {
			pRetAuthor = pNonfictionAuthor;   
			}
		}
		else {
		if ( _t!=NULL && (_t->token==Tok_fictionauthor_gram||_t->token==Tok_humorfictionauthor_gram||
		_t->token==Tok_romanticfictionauthor_gram) ) {
			FictionAuthor * pFictionAuthor;   
			 pFictionAuthor =fictionauthor_super_sor(_parser, &_t);
			if ( !_parser->guessing ) {
			pRetAuthor = pFictionAuthor;   
			}
		}
		else {
			if ( _parser->guessing ) _GUESS_FAIL;
			no_viable_alt(_parser, "author_super_sor", _t);
		}
		}
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "author_super_sor", _t);
	}
	*_root = _t;
	return pRetAuthor;
} // author_super_sor

 Author *   author_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 Author * pRetAuthor ;
	if ( _t!=NULL && (_t->token==Tok_author_gram) ) {
		Author * pAuthor = new Author;
		KrString * pId = NULL;
		{_SAVE;
		_MATCH(Tok_author_gram); _DOWN;
		 pId =author_id_sor(_parser, &_t);
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_authnotestitle_gram||_t->token==Tok_name_gram||
			_t->token==Tok_authnotes_list_gram||_t->token==Tok_worksinprogress_list_gram||_t->token==Tok_publishedworks_list_gram) ) {
				author_item_sor(_parser, &_t,  pAuthor );
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "author_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pAuthor->Set_id(pId);
		pRetAuthor = pAuthor;
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "author_sor", _t);
	}
	*_root = _t;
	return pRetAuthor;
} // author_sor

 KrString *   author_id_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetId ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_author_id_gram) ) {
		KrString * pStr = NULL;   
		{_SAVE;
		_MATCH(Tok_author_id_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		pStr = new KrString(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetId = pStr;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "author_id_sor", _t);
	}
	*_root = _t;
	return pRetId;
} // author_id_sor

void author_item_sor(STreeParser *_parser, AST **_root, Author * pAuthor )
{
	AST *_t = *_root;
	if ( _t!=NULL && (_t->token==Tok_name_gram) ) {
		KrString * pStr;   
		 pStr =name_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pAuthor->Set_name(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_publishedworks_list_gram) ) {
		DocumentList * pList;   
		 pList =publishedworks_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pAuthor->Set_publishedWorks(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_worksinprogress_list_gram) ) {
		DocumentList * pList;   
		 pList =worksinprogress_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pAuthor->Set_worksInProgress(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authnotes_list_gram) ) {
		KrStringList * pList;   
		 pList =authnotes_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pAuthor->Set_authNotes(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authnotestitle_gram) ) {
		KrString * pStr;   
		 pStr =authnotestitle_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pAuthor->Set_authnotesTitle(pStr);   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "author_item_sor", _t);
	}
	}
	}
	}
	}
	*_root = _t;
} // author_item_sor

 FictionAuthor *   fictionauthor_super_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 FictionAuthor * pRetFictionAuthor ;
	if ( _t!=NULL && (_t->token==Tok_fictionauthor_gram||_t->token==Tok_humorfictionauthor_gram||
	_t->token==Tok_romanticfictionauthor_gram) ) {
		if ( _t!=NULL && (_t->token==Tok_fictionauthor_gram) ) {
			FictionAuthor * pFictionAuthor;   
			 pFictionAuthor =fictionauthor_sor(_parser, &_t);
			if ( !_parser->guessing ) {
			pRetFictionAuthor = pFictionAuthor;   
			}
		}
		else {
		if ( _t!=NULL && (_t->token==Tok_humorfictionauthor_gram) ) {
			HumorFictionAuthor * pHumorFictionAuthor;   
			 pHumorFictionAuthor =humorfictionauthor_sor(_parser, &_t);
			if ( !_parser->guessing ) {
			pRetFictionAuthor = pHumorFictionAuthor;   
			}
		}
		else {
		if ( _t!=NULL && (_t->token==Tok_romanticfictionauthor_gram) ) {
			RomanticFictionAuthor * pRomanticFictionAuthor;   
			 pRomanticFictionAuthor =romanticfictionauthor_sor(_parser, &_t);
			if ( !_parser->guessing ) {
			pRetFictionAuthor = pRomanticFictionAuthor;   
			}
		}
		else {
			if ( _parser->guessing ) _GUESS_FAIL;
			no_viable_alt(_parser, "fictionauthor_super_sor", _t);
		}
		}
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "fictionauthor_super_sor", _t);
	}
	*_root = _t;
	return pRetFictionAuthor;
} // fictionauthor_super_sor

 FictionAuthor *   fictionauthor_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 FictionAuthor * pRetFictionAuthor ;
	if ( _t!=NULL && (_t->token==Tok_fictionauthor_gram) ) {
		FictionAuthor * pFictionAuthor = new FictionAuthor;
		KrString * pId = NULL;
		{_SAVE;
		_MATCH(Tok_fictionauthor_gram); _DOWN;
		 pId =fictionauthor_id_sor(_parser, &_t);
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_authnotestitle_gram||_t->token==Tok_name_gram||
			_t->token==Tok_topicarea_gram||_t->token==Tok_authnotes_list_gram||_t->token==Tok_worksinprogress_list_gram||
			_t->token==Tok_publishedworks_list_gram) ) {
				fictionauthor_item_sor(_parser, &_t,  pFictionAuthor );
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "fictionauthor_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pFictionAuthor->Set_id(pId);
		pRetFictionAuthor = pFictionAuthor;
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "fictionauthor_sor", _t);
	}
	*_root = _t;
	return pRetFictionAuthor;
} // fictionauthor_sor

 KrString *   fictionauthor_id_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetId ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_fictionauthor_id_gram) ) {
		KrString * pStr = NULL;   
		{_SAVE;
		_MATCH(Tok_fictionauthor_id_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		pStr = new KrString(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetId = pStr;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "fictionauthor_id_sor", _t);
	}
	*_root = _t;
	return pRetId;
} // fictionauthor_id_sor

void fictionauthor_item_sor(STreeParser *_parser, AST **_root, FictionAuthor * pFictionAuthor )
{
	AST *_t = *_root;
	if ( _t!=NULL && (_t->token==Tok_topicarea_gram) ) {
		KrString * pStr;   
		 pStr =topicarea_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pFictionAuthor->Set_topicArea(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_name_gram) ) {
		KrString * pStr;   
		 pStr =name_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pFictionAuthor->Set_name(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_publishedworks_list_gram) ) {
		DocumentList * pList;   
		 pList =publishedworks_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pFictionAuthor->Set_publishedWorks(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_worksinprogress_list_gram) ) {
		DocumentList * pList;   
		 pList =worksinprogress_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pFictionAuthor->Set_worksInProgress(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authnotes_list_gram) ) {
		KrStringList * pList;   
		 pList =authnotes_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pFictionAuthor->Set_authNotes(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authnotestitle_gram) ) {
		KrString * pStr;   
		 pStr =authnotestitle_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pFictionAuthor->Set_authnotesTitle(pStr);   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "fictionauthor_item_sor", _t);
	}
	}
	}
	}
	}
	}
	*_root = _t;
} // fictionauthor_item_sor

 HumorFictionAuthor *   humorfictionauthor_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 HumorFictionAuthor * pRetHumorFictionAuthor ;
	if ( _t!=NULL && (_t->token==Tok_humorfictionauthor_gram) ) {
		HumorFictionAuthor * pHumorFictionAuthor = new HumorFictionAuthor;
		KrString * pId = NULL;
		{_SAVE;
		_MATCH(Tok_humorfictionauthor_gram); _DOWN;
		 pId =humorfictionauthor_id_sor(_parser, &_t);
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_authnotestitle_gram||_t->token==Tok_name_gram||
			_t->token==Tok_topicarea_gram||_t->token==Tok_style_gram||_t->token==Tok_authnotes_list_gram||
			_t->token==Tok_worksinprogress_list_gram||_t->token==Tok_publishedworks_list_gram) ) {
				humorfictionauthor_item_sor(_parser, &_t,  pHumorFictionAuthor );
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "humorfictionauthor_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pHumorFictionAuthor->Set_id(pId);
		pRetHumorFictionAuthor = pHumorFictionAuthor;
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "humorfictionauthor_sor", _t);
	}
	*_root = _t;
	return pRetHumorFictionAuthor;
} // humorfictionauthor_sor

 KrString *   humorfictionauthor_id_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetId ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_humorfictionauthor_id_gram) ) {
		KrString * pStr = NULL;   
		{_SAVE;
		_MATCH(Tok_humorfictionauthor_id_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		pStr = new KrString(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetId = pStr;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "humorfictionauthor_id_sor", _t);
	}
	*_root = _t;
	return pRetId;
} // humorfictionauthor_id_sor

void humorfictionauthor_item_sor(STreeParser *_parser, AST **_root, HumorFictionAuthor * pHumorFictionAuthor )
{
	AST *_t = *_root;
	if ( _t!=NULL && (_t->token==Tok_style_gram) ) {
		KrString * pStr;   
		 pStr =style_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pHumorFictionAuthor->Set_style(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_topicarea_gram) ) {
		KrString * pStr;   
		 pStr =topicarea_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pHumorFictionAuthor->Set_topicArea(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_name_gram) ) {
		KrString * pStr;   
		 pStr =name_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pHumorFictionAuthor->Set_name(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_publishedworks_list_gram) ) {
		DocumentList * pList;   
		 pList =publishedworks_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pHumorFictionAuthor->Set_publishedWorks(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_worksinprogress_list_gram) ) {
		DocumentList * pList;   
		 pList =worksinprogress_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pHumorFictionAuthor->Set_worksInProgress(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authnotes_list_gram) ) {
		KrStringList * pList;   
		 pList =authnotes_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pHumorFictionAuthor->Set_authNotes(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authnotestitle_gram) ) {
		KrString * pStr;   
		 pStr =authnotestitle_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pHumorFictionAuthor->Set_authnotesTitle(pStr);   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "humorfictionauthor_item_sor", _t);
	}
	}
	}
	}
	}
	}
	}
	*_root = _t;
} // humorfictionauthor_item_sor

 RomanticFictionAuthor *   romanticfictionauthor_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 RomanticFictionAuthor * pRetRomanticFictionAuthor ;
	if ( _t!=NULL && (_t->token==Tok_romanticfictionauthor_gram) ) {
		RomanticFictionAuthor * pRomanticFictionAuthor = new RomanticFictionAuthor;
		KrString * pId = NULL;
		{_SAVE;
		_MATCH(Tok_romanticfictionauthor_gram); _DOWN;
		 pId =romanticfictionauthor_id_sor(_parser, &_t);
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_authnotestitle_gram||_t->token==Tok_name_gram||
			_t->token==Tok_topicarea_gram||_t->token==Tok_period_gram||_t->token==Tok_emotionaltemperature_gram||
			_t->token==Tok_authnotes_list_gram||_t->token==Tok_worksinprogress_list_gram||_t->token==Tok_publishedworks_list_gram) ) {
				romanticfictionauthor_item_sor(_parser, &_t,  pRomanticFictionAuthor );
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "romanticfictionauthor_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRomanticFictionAuthor->Set_id(pId);
		pRetRomanticFictionAuthor = pRomanticFictionAuthor;
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "romanticfictionauthor_sor", _t);
	}
	*_root = _t;
	return pRetRomanticFictionAuthor;
} // romanticfictionauthor_sor

 KrString *   romanticfictionauthor_id_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetId ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_romanticfictionauthor_id_gram) ) {
		KrString * pStr = NULL;   
		{_SAVE;
		_MATCH(Tok_romanticfictionauthor_id_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		pStr = new KrString(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetId = pStr;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "romanticfictionauthor_id_sor", _t);
	}
	*_root = _t;
	return pRetId;
} // romanticfictionauthor_id_sor

void romanticfictionauthor_item_sor(STreeParser *_parser, AST **_root, RomanticFictionAuthor * pRomanticFictionAuthor )
{
	AST *_t = *_root;
	if ( _t!=NULL && (_t->token==Tok_period_gram) ) {
		KrString * pStr;   
		 pStr =period_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pRomanticFictionAuthor->Set_period(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_emotionaltemperature_gram) ) {
		float emotionalTemperature;   
		 emotionalTemperature =emotionaltemperature_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pRomanticFictionAuthor->Set_emotionalTemperature(emotionalTemperature);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_topicarea_gram) ) {
		KrString * pStr;   
		 pStr =topicarea_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pRomanticFictionAuthor->Set_topicArea(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_name_gram) ) {
		KrString * pStr;   
		 pStr =name_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pRomanticFictionAuthor->Set_name(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_publishedworks_list_gram) ) {
		DocumentList * pList;   
		 pList =publishedworks_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pRomanticFictionAuthor->Set_publishedWorks(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_worksinprogress_list_gram) ) {
		DocumentList * pList;   
		 pList =worksinprogress_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pRomanticFictionAuthor->Set_worksInProgress(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authnotes_list_gram) ) {
		KrStringList * pList;   
		 pList =authnotes_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pRomanticFictionAuthor->Set_authNotes(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authnotestitle_gram) ) {
		KrString * pStr;   
		 pStr =authnotestitle_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pRomanticFictionAuthor->Set_authnotesTitle(pStr);   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "romanticfictionauthor_item_sor", _t);
	}
	}
	}
	}
	}
	}
	}
	}
	*_root = _t;
} // romanticfictionauthor_item_sor

 NonfictionAuthor *   nonfictionauthor_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 NonfictionAuthor * pRetNonfictionAuthor ;
	if ( _t!=NULL && (_t->token==Tok_nonfictionauthor_gram) ) {
		NonfictionAuthor * pNonfictionAuthor = new NonfictionAuthor;
		KrString * pId = NULL;
		{_SAVE;
		_MATCH(Tok_nonfictionauthor_gram); _DOWN;
		 pId =nonfictionauthor_id_sor(_parser, &_t);
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_authnotestitle_gram||_t->token==Tok_name_gram||
			_t->token==Tok_doccount_gram||_t->token==Tok_authnotes_list_gram||_t->token==Tok_worksinprogress_list_gram||
			_t->token==Tok_publishedworks_list_gram||_t->token==Tok_biases_list_gram||_t->token==Tok_specialfields_list_gram) ) {
				nonfictionauthor_item_sor(_parser, &_t,  pNonfictionAuthor );
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "nonfictionauthor_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pNonfictionAuthor->Set_id(pId);
		pRetNonfictionAuthor = pNonfictionAuthor;
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "nonfictionauthor_sor", _t);
	}
	*_root = _t;
	return pRetNonfictionAuthor;
} // nonfictionauthor_sor

 KrString *   nonfictionauthor_id_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetId ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_nonfictionauthor_id_gram) ) {
		KrString * pStr = NULL;   
		{_SAVE;
		_MATCH(Tok_nonfictionauthor_id_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		pStr = new KrString(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetId = pStr;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "nonfictionauthor_id_sor", _t);
	}
	*_root = _t;
	return pRetId;
} // nonfictionauthor_id_sor

void nonfictionauthor_item_sor(STreeParser *_parser, AST **_root, NonfictionAuthor * pNonfictionAuthor )
{
	AST *_t = *_root;
	if ( _t!=NULL && (_t->token==Tok_doccount_gram) ) {
		int docCount;   
		 docCount =doccount_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pNonfictionAuthor->Set_docCount(docCount);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_specialfields_list_gram) ) {
		KrStringList * pList;   
		 pList =specialfields_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pNonfictionAuthor->Set_specialFields(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_biases_list_gram) ) {
		KrStringList * pList;   
		 pList =biases_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pNonfictionAuthor->Set_biases(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_name_gram) ) {
		KrString * pStr;   
		 pStr =name_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pNonfictionAuthor->Set_name(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_publishedworks_list_gram) ) {
		DocumentList * pList;   
		 pList =publishedworks_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pNonfictionAuthor->Set_publishedWorks(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_worksinprogress_list_gram) ) {
		DocumentList * pList;   
		 pList =worksinprogress_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pNonfictionAuthor->Set_worksInProgress(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authnotes_list_gram) ) {
		KrStringList * pList;   
		 pList =authnotes_list_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pNonfictionAuthor->Set_authNotes(pList);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_authnotestitle_gram) ) {
		KrString * pStr;   
		 pStr =authnotestitle_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pNonfictionAuthor->Set_authnotesTitle(pStr);   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "nonfictionauthor_item_sor", _t);
	}
	}
	}
	}
	}
	}
	}
	}
	*_root = _t;
} // nonfictionauthor_item_sor

 Pubs *   pubs_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 Pubs * pRetPubs ;
	if ( _t!=NULL && (_t->token==Tok_pubs_gram) ) {
		Pubs * pPubs = new Pubs;
		KrString * pId = NULL;
		{_SAVE;
		_MATCH(Tok_pubs_gram); _DOWN;
		 pId =pubs_id_sor(_parser, &_t);
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_date_gram||_t->token==Tok_location_gram||
			_t->token==Tok_publisher_gram) ) {
				pubs_item_sor(_parser, &_t,  pPubs );
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "pubs_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pPubs->Set_id(pId);
		pRetPubs = pPubs;
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "pubs_sor", _t);
	}
	*_root = _t;
	return pRetPubs;
} // pubs_sor

 KrString *   pubs_id_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetId ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_pubs_id_gram) ) {
		KrString * pStr = NULL;   
		{_SAVE;
		_MATCH(Tok_pubs_id_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		pStr = new KrString(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetId = pStr;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "pubs_id_sor", _t);
	}
	*_root = _t;
	return pRetId;
} // pubs_id_sor

void pubs_item_sor(STreeParser *_parser, AST **_root, Pubs * pPubs )
{
	AST *_t = *_root;
	if ( _t!=NULL && (_t->token==Tok_publisher_gram) ) {
		KrString * pStr;   
		 pStr =publisher_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pPubs->Set_publisher(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_location_gram) ) {
		KrString * pStr;   
		 pStr =location_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pPubs->Set_location(pStr);   
		}
	}
	else {
	if ( _t!=NULL && (_t->token==Tok_date_gram) ) {
		KrString * pStr;   
		 pStr =date_sor(_parser, &_t);
		if ( !_parser->guessing ) {
		pPubs->Set_date(pStr);   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "pubs_item_sor", _t);
	}
	}
	}
	*_root = _t;
} // pubs_item_sor

 KrString *   date_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_date_gram) ) {
		{_SAVE;
		_MATCH(Tok_date_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "date_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // date_sor

 KrString *   location_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_location_gram) ) {
		{_SAVE;
		_MATCH(Tok_location_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "location_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // location_sor

 KrString *   publisher_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_publisher_gram) ) {
		{_SAVE;
		_MATCH(Tok_publisher_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "publisher_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // publisher_sor

 KrString *   authnotestitle_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_authnotestitle_gram) ) {
		{_SAVE;
		_MATCH(Tok_authnotestitle_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "authnotestitle_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // authnotestitle_sor

 KrString *   name_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_name_gram) ) {
		{_SAVE;
		_MATCH(Tok_name_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "name_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // name_sor

 KrString *   topicarea_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_topicarea_gram) ) {
		{_SAVE;
		_MATCH(Tok_topicarea_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "topicarea_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // topicarea_sor

 KrString *   period_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_period_gram) ) {
		{_SAVE;
		_MATCH(Tok_period_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "period_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // period_sor

 KrString *   style_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_style_gram) ) {
		{_SAVE;
		_MATCH(Tok_style_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "style_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // style_sor

 KrString *   docnotestitle_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_docnotestitle_gram) ) {
		{_SAVE;
		_MATCH(Tok_docnotestitle_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "docnotestitle_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // docnotestitle_sor

 KrString *   authorid_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_authorid_gram) ) {
		{_SAVE;
		_MATCH(Tok_authorid_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "authorid_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // authorid_sor

 KrString *   doctitle_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_doctitle_gram) ) {
		{_SAVE;
		_MATCH(Tok_doctitle_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "doctitle_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // doctitle_sor

 KrString *   bibltitle_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetString ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_bibltitle_gram) ) {
		{_SAVE;
		_MATCH(Tok_bibltitle_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pString = new KrString(u->str);
		pRetString = pString;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "bibltitle_sor", _t);
	}
	*_root = _t;
	return pRetString;
} // bibltitle_sor

 int   selecteditem_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 int retselecteditem ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_selecteditem_gram) ) {
		{_SAVE;
		_MATCH(Tok_selecteditem_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		
		if (strcmp(u->str, "true") == 0)
		{
			retselecteditem = 1;
		} // if
		else
		{
			retselecteditem = 0;
		} // else
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "selecteditem_sor", _t);
	}
	*_root = _t;
	return retselecteditem;
} // selecteditem_sor

 int   doccount_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 int retdoccount ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_doccount_gram) ) {
		{_SAVE;
		_MATCH(Tok_doccount_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		retdoccount = atoi(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "doccount_sor", _t);
	}
	*_root = _t;
	return retdoccount;
} // doccount_sor

 float   emotionaltemperature_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 float retemotionaltemperature ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_emotionaltemperature_gram) ) {
		{_SAVE;
		_MATCH(Tok_emotionaltemperature_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		retemotionaltemperature = (float)atof(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "emotionaltemperature_sor", _t);
	}
	*_root = _t;
	return retemotionaltemperature;
} // emotionaltemperature_sor

 KrStringList *   authnotes_list_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrStringList * pRetList ;
	if ( _t!=NULL && (_t->token==Tok_authnotes_list_gram) ) {
		KrStringList * pList = new KrStringList; 
		KrString * pKrString;
		{_SAVE;
		_MATCH(Tok_authnotes_list_gram); _DOWN;
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_string_gram) ) {
				 pKrString =string_sor(_parser, &_t);
				if ( !_parser->guessing ) {
				pList->Insert(pKrString, 0);   
				}
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "authnotes_list_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetList = pList;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "authnotes_list_sor", _t);
	}
	*_root = _t;
	return pRetList;
} // authnotes_list_sor

 DocumentList *   worksinprogress_list_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 DocumentList * pRetList ;
	if ( _t!=NULL && (_t->token==Tok_worksinprogress_list_gram) ) {
		DocumentList * pList = new DocumentList; 
		Document * pDocument;
		{_SAVE;
		_MATCH(Tok_worksinprogress_list_gram); _DOWN;
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_document_gram) ) {
				 pDocument =document_sor(_parser, &_t);
				if ( !_parser->guessing ) {
				pList->Insert(pDocument, 0);   
				}
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "worksinprogress_list_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetList = pList;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "worksinprogress_list_sor", _t);
	}
	*_root = _t;
	return pRetList;
} // worksinprogress_list_sor

 DocumentList *   publishedworks_list_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 DocumentList * pRetList ;
	if ( _t!=NULL && (_t->token==Tok_publishedworks_list_gram) ) {
		DocumentList * pList = new DocumentList; 
		Document * pDocument;
		{_SAVE;
		_MATCH(Tok_publishedworks_list_gram); _DOWN;
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_document_gram) ) {
				 pDocument =document_sor(_parser, &_t);
				if ( !_parser->guessing ) {
				pList->Insert(pDocument, 0);   
				}
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "publishedworks_list_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetList = pList;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "publishedworks_list_sor", _t);
	}
	*_root = _t;
	return pRetList;
} // publishedworks_list_sor

 KrStringList *   biases_list_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrStringList * pRetList ;
	if ( _t!=NULL && (_t->token==Tok_biases_list_gram) ) {
		KrStringList * pList = new KrStringList; 
		KrString * pKrString;
		{_SAVE;
		_MATCH(Tok_biases_list_gram); _DOWN;
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_string_gram) ) {
				 pKrString =string_sor(_parser, &_t);
				if ( !_parser->guessing ) {
				pList->Insert(pKrString, 0);   
				}
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "biases_list_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetList = pList;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "biases_list_sor", _t);
	}
	*_root = _t;
	return pRetList;
} // biases_list_sor

 KrStringList *   specialfields_list_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrStringList * pRetList ;
	if ( _t!=NULL && (_t->token==Tok_specialfields_list_gram) ) {
		KrStringList * pList = new KrStringList; 
		KrString * pKrString;
		{_SAVE;
		_MATCH(Tok_specialfields_list_gram); _DOWN;
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_string_gram) ) {
				 pKrString =string_sor(_parser, &_t);
				if ( !_parser->guessing ) {
				pList->Insert(pKrString, 0);   
				}
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "specialfields_list_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetList = pList;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "specialfields_list_sor", _t);
	}
	*_root = _t;
	return pRetList;
} // specialfields_list_sor

 KrStringList *   docnotes_list_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrStringList * pRetList ;
	if ( _t!=NULL && (_t->token==Tok_docnotes_list_gram) ) {
		KrStringList * pList = new KrStringList; 
		KrString * pKrString;
		{_SAVE;
		_MATCH(Tok_docnotes_list_gram); _DOWN;
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_string_gram) ) {
				 pKrString =string_sor(_parser, &_t);
				if ( !_parser->guessing ) {
				pList->Insert(pKrString, 0);   
				}
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "docnotes_list_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetList = pList;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "docnotes_list_sor", _t);
	}
	*_root = _t;
	return pRetList;
} // docnotes_list_sor

 KrStringList *   xrefs_list_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrStringList * pRetList ;
	if ( _t!=NULL && (_t->token==Tok_xrefs_list_gram) ) {
		KrStringList * pList = new KrStringList; 
		KrString * pKrString;
		{_SAVE;
		_MATCH(Tok_xrefs_list_gram); _DOWN;
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_string_gram) ) {
				 pKrString =string_sor(_parser, &_t);
				if ( !_parser->guessing ) {
				pList->Insert(pKrString, 0);   
				}
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "xrefs_list_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetList = pList;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "xrefs_list_sor", _t);
	}
	*_root = _t;
	return pRetList;
} // xrefs_list_sor

 KrStringList *   keywords_list_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrStringList * pRetList ;
	if ( _t!=NULL && (_t->token==Tok_keywords_list_gram) ) {
		KrStringList * pList = new KrStringList; 
		KrString * pKrString;
		{_SAVE;
		_MATCH(Tok_keywords_list_gram); _DOWN;
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_string_gram) ) {
				 pKrString =string_sor(_parser, &_t);
				if ( !_parser->guessing ) {
				pList->Insert(pKrString, 0);   
				}
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "keywords_list_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetList = pList;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "keywords_list_sor", _t);
	}
	*_root = _t;
	return pRetList;
} // keywords_list_sor

 AuthorList *   authors_list_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 AuthorList * pRetList ;
	if ( _t!=NULL && (_t->token==Tok_authors_list_gram) ) {
		AuthorList * pList = new AuthorList; 
		Author * pAuthor;
		{_SAVE;
		_MATCH(Tok_authors_list_gram); _DOWN;
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_author_gram||_t->token==Tok_fictionauthor_gram||
			_t->token==Tok_humorfictionauthor_gram||_t->token==Tok_romanticfictionauthor_gram||_t->token==Tok_nonfictionauthor_gram) ) {
				 pAuthor =author_super_sor(_parser, &_t);
				if ( !_parser->guessing ) {
				pList->Insert(pAuthor, 0);   
				}
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "authors_list_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetList = pList;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "authors_list_sor", _t);
	}
	*_root = _t;
	return pRetList;
} // authors_list_sor

 DocumentList *   documents_list_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 DocumentList * pRetList ;
	if ( _t!=NULL && (_t->token==Tok_documents_list_gram) ) {
		DocumentList * pList = new DocumentList; 
		Document * pDocument;
		{_SAVE;
		_MATCH(Tok_documents_list_gram); _DOWN;
		{int _done=0;
		while ( !_done ) {
			if ( _t!=NULL && (_t->token==Tok_document_gram) ) {
				 pDocument =document_sor(_parser, &_t);
				if ( !_parser->guessing ) {
				pList->Insert(pDocument, 0);   
				}
			}
			else {
			if ( _t==NULL ) {
				_done = 1;
			}
			else {
				if ( _parser->guessing ) _GUESS_FAIL;
				no_viable_alt(_parser, "documents_list_sor", _t);
			}
			}
		}}
		_RESTORE;}
		 _RIGHT;
		if ( !_parser->guessing ) {
		pRetList = pList;   
		}
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "documents_list_sor", _t);
	}
	*_root = _t;
	return pRetList;
} // documents_list_sor

 KrString *   string_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 KrString * pRetStr ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_string_gram) ) {
		{_SAVE;
		_MATCH(Tok_string_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		KrString * pStr = new KrString(u->str);
		pRetStr = pStr;
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "string_sor", _t);
	}
	*_root = _t;
	return pRetStr;
} // string_sor

 int   int_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 int retInt ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_int_gram) ) {
		{_SAVE;
		_MATCH(Tok_int_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		retInt = atoi(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "int_sor", _t);
	}
	*_root = _t;
	return retInt;
} // int_sor

 float   float_sor(STreeParser *_parser, AST **_root)
{
	AST *_t = *_root;
	 float retFloat ;
	AST *u=NULL;
	if ( _t!=NULL && (_t->token==Tok_float_gram) ) {
		{_SAVE;
		_MATCH(Tok_float_gram); _SETLABEL(u); _DOWN;
		if ( !_parser->guessing ) {
		retFloat = (float)atof(u->str);   
		}
		_RESTORE;}
		 _RIGHT;
	}
	else {
		if ( _parser->guessing ) _GUESS_FAIL;
		no_viable_alt(_parser, "float_sor", _t);
	}
	*_root = _t;
	return retFloat;
} // float_sor
