#ifndef AST_H
#define AST_H

/*
 * AST.h
 *
 * SOFTWARE RIGHTS
 *
 * We reserve no LEGAL rights to SORCERER -- SORCERER is in the public
 * domain.  An individual or company may do whatever they wish with
 * source code distributed with SORCERER or the code generated by
 * SORCERER, including the incorporation of SORCERER, or its output, into
 * commerical software.
 * 
 * We encourage users to develop software with SORCERER.  However, we do
 * ask that credit is given to us for developing SORCERER.  By "credit",
 * we mean that if you incorporate our source code into one of your
 * programs (commercial product, research project, or otherwise) that you
 * acknowledge this fact somewhere in the documentation, research report,
 * etc...  If you like SORCERER and have developed a nice tool with the
 * output, please mention that you developed it using SORCERER.  In
 * addition, we ask that this header remain intact in our source code.
 * As long as these guidelines are kept, we expect to continue enhancing
 * this system and expect to make other tools available as they are
 * completed.
 *
 * SORCERER 1.00B
 * Terence Parr
 * AHPCRC, University of Minnesota
 * 1992-1994
 */
#include <setjmp.h>
#include "sorcerer.h"
#include "SList.h"

#define MaxTreeStackDepth	400

#define ast_make_rw			ast_make
#define ast_find_all_rw		ast_find_all
#define ast_match_rw		ast_match
#define ast_match_partial_rw	ast_match_partial
#define ast_insert_after_rw	ast_insert_after
#define ast_append_rw		ast_append
#define ast_tail_rw			ast_tail
#define ast_bottom_rw		ast_bottom
#define ast_cut_between_rw	ast_cut_between
#define ast_to_slist_rw		ast_to_slist
#define slist_to_ast_rw		slist_to_ast
#define ast_free_rw			ast_free
#define ast_scan_rw			ast_scan
#define ast_nsiblings_rw	ast_nsiblings
#define ast_siblings_index_rw	ast_sibling_index

#ifdef __USE_PROTOS
extern AST *ast_make(int _rw, AST *rt, ...);
extern AST *ast_find_all(int rw, AST *t, AST *u, AST **cursor);
extern int ast_match(int rw, AST *t, AST *u);
extern void ast_insert_after(int rw, AST *a, AST *b);
extern void ast_append(int rw, AST *a, AST *b);
extern AST *ast_tail(int rw, AST *a);
extern AST *ast_bottom(int rw, AST *a);
extern AST *ast_cut_between(int rw, AST *a, AST *b);
extern SList *ast_to_slist(int rw, AST *t);
extern AST *slist_to_ast(int rw,SList *list);
extern void ast_free(int rw, AST *t);
extern int ast_scan(int rw, char *template, AST *tree, ...);
extern int ast_nsiblings(int rw, AST *t);
extern AST *ast_sibling_index(int rw, AST *t, int i);
extern void ast_copy_pointers(AST *t, int p1, int p2);
#else
extern AST *ast_make();
extern AST *ast_find_all();
extern int ast_match();
extern void ast_insert_after();
extern void ast_append();
extern AST *ast_tail();
extern AST *ast_bottom();
extern AST *ast_cut_between();
extern SList *ast_to_slist();
extern AST *slist_to_ast();
extern void ast_free();
extern int ast_scan();
extern int ast_nsiblings();
extern AST *ast_sibling_index();
extern void ast_copy_pointers();
#endif

#endif
