/*
 * sorcerer.c -- support code for SORCERER output
 *
 * Define your own or compile and link this in.
 *
 * Terence Parr
 * U of MN, AHPCRC
 * February 1994
 */

/* Given a result pointer, return the same one if *t is NULL,
 * else find the end of the sibling list and return the address
 * the 'next[write]' field in that last node.
 */
AST **
#ifdef __USE_PROTOS
_nextresult(STreeParser *_parser, AST **t)
#else
_nextresult(_parser, t)
AST **t;
STreeParser *_parser;
#endif
{
	AST *p = *t;

	if ( p==NULL ) return t;
	while ( p->ast_right(_parser->write) != NULL )
	{
		p = p->ast_right(_parser->write);
	}
	return &(p->ast_right(_parser->write));
}

/*
 * Copy the read pointers to the write pointers for a node or entire subtree
 */
void
#ifdef __USE_PROTOS
_copy_wildcard(STreeParser *_parser, AST *t, int root)
#else
_copy_wildcard(_parser, t, root)
STreeParser *_parser;
AST *t;
int root;
#endif
{
	while ( t!=NULL )
	{
		if ( !root ) t->ast_right(_parser->write) = t->ast_right(_parser->read);
		t->ast_down(_parser->write) = t->ast_down(_parser->read);
		if ( t->ast_down(_parser->read)!=NULL )
			_copy_wildcard(_parser, t->ast_down(_parser->read), 0);
		if ( root ) return;
		else root=0;
		t = t->ast_right(_parser->read);
	}
}

