// mdlsup.hpp    Class definitions for MdlSupport

/*
* Copyright (c) 1994 G. David Kuhlman.
* All rights reserved.
*
* Permission is hereby granted, without written agreement and without
* license or royalty fees, to use, copy, modify, and distribute this
* software and its documentation for any purpose, provided that the
* above copyright notice and the following two paragraphs appear in
* all copies of this software.
* 
* IN NO EVENT SHALL G. DAVID KUHLMAN BE LIABLE TO ANY PARTY FOR
* DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
* OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF G. DAVID KUHLMAN
* HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* G. DAVID KUHLMAN SPECIFICALLY DISCLAIMS ANY WARRANTIES,
* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
* AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
* ON AN "AS IS" BASIS, AND G. DAVID KUHLMAN HAS NO OBLIGATION TO
* PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*/

// The MdlSupport class/object contains global general support functions.

#ifndef mdlsup_HPP
#define mdlsup_HPP


class MdlSupport {
public:
    // Error reporting function.
    static void ReportError(char * msg, int level);
    // Level numbers for GmeError.
    enum {
        MDL_ERROR_LEVEL_1 = 1,
        MDL_ERROR_LEVEL_2,
        MDL_ERROR_LEVEL_3,
        MDL_ERROR_LEVEL_4
    }; 
    typedef int ErrStat;
protected:
private:
    // The constructors and destructors are private so that 
    //  we can't create any instances of this class.
    MdlSupport();
    MdlSupport(const MdlSupport& rhs);
    ~MdlSupport();
    MdlSupport& operator =(const MdlSupport& rhs);
}; // MdlSupport

#endif // mdlsup_HPP

