
#include <stdlib.h>
#include <iostream.h>

#include <db.hpp>
#include <dbblk.hpp>
#include <mdlsyn.hpp>
#include "krstrg.hpp"
#include "krstrm.hpp"
#include "kr.hpp"
#include "db.hpp"
#include "bt.h"

// ---------------------------------------------------------



// ---------------------------------------------------------

Bibliography * buildkr(void);
void testkr(Bibliography * pB1, char * dbname, char * objname);
void loadkr(char * dbname, char * objname);

// ---------------------------------------------------------

void main(int argc, char ** argv)
{
    if (argc != 3)
    {
        cerr << "Usage: test <dbname> <objname>" << endl;
        exit(-1);
    } // if

    Bibliography * pB = buildkr();

    testkr(pB, argv[1], argv[2]);

    loadkr(argv[1], argv[2]);

} // main

// ---------------------------------------------------------

Bibliography * buildkr(void)
{
    KrString * id;
    KrString * pStr;
    KrStringList * pSL;
    DocumentList * pDL;
    AuthorList * pAL;
    Bibliography * pB1;
    HumorFictionAuthor * pA1;
    HumorFictionAuthor * pA2;
    FictionAuthor * pA3;
    RomanticFictionAuthor * pA4;
    Document * pD1;

    pB1 = new Bibliography;
    pB1->Set_bibltitle(new KrString("A bibliography of humorous works"));
    id = new KrString("B1");
    pB1->Set_id(id);

    pAL = new AuthorList;

    pA1 = new HumorFictionAuthor;
    pA1->Set_name(new KrString("Dave Barry"));
    id = new KrString("A1");
    pA1->Set_id(id);

    pSL = new KrStringList;
    pSL->Append(new KrString("Has weekly column"));
    pSL->Append(new KrString("Meaningless social commentary"));
    pSL->Append(new KrString("Hates Barbie dolls"));

    pA1->Set_authnotesTitle(new KrString("Funny Dave"));
    pAL->Append(pA1);

    pDL = new DocumentList;

    pD1 = new Document;
    pStr = new KrString("Babies and other hazards of marriage");
    pD1->Set_selectedItem(true);
    pD1->Set_doctitle(pStr);
    id = new KrString("D3");
    pD1->Set_id(id);
    pSL = new KrStringList;
    pStr = new KrString("humor");
    pSL->Append(pStr);
    pStr = new KrString("baby");
    pSL->Append(pStr);
    pStr = new KrString("love");
    pSL->Append(pStr);
    pStr = new KrString("marriage");
    pSL->Append(pStr);
    pD1->Set_keywords(pSL);
    pSL = new KrStringList;
    pStr = new KrString("Don't read this if you are about to get married.");
    pSL->Append(pStr);
    pStr = new KrString("Totally worthless advice about life and love.");
    pSL->Append(pStr);
    pStr = new KrString("He is REALLY making this up.");
    pSL->Append(pStr);
    pD1->Set_docnotes(pSL);
    pD1->Set_docnotesTitle(new KrString("Babies and hazards"));
    pDL->Append(pD1);

    pA1->Set_publishedWorks(pDL);

    pA1 = new HumorFictionAuthor;
    pA1->Set_name(new KrString("Mark Twain"));
    id = new KrString("A2");
    pA1->Set_id(id);

    pSL = new KrStringList;
    pStr = new KrString("Very sarcastic");
    pSL->Append(pStr);
    pStr = new KrString("Rustic; writes about the far west and life on the frontier");
    pSL->Append(pStr);
    pA1->Set_authNotes(pSL);

    pA1->Set_authnotesTitle(new KrString("Funny Mark"));

    pDL = new DocumentList;

    pD1 = new Document;
    pStr = new KrString("The celebrated jumping frog of Calaveras County");
    pD1->Set_doctitle(pStr);
    id = new KrString("D4");
    pD1->Set_id(id);
    pSL = new KrStringList;
    pStr = new KrString("humor");
    pSL->Append(pStr);
    pStr = new KrString("frog");
    pSL->Append(pStr);
    pStr = new KrString("contest");
    pSL->Append(pStr);
    pStr = new KrString("calaveras");
    pSL->Append(pStr);
    pD1->Set_keywords(pSL);

    pSL = new KrStringList;
    pStr = new KrString("Goofiness about eastern California.");
    pSL->Append(pStr);
    pStr = new KrString("A race that is not really a race.");
    pSL->Append(pStr);
    pD1->Set_docnotes(pSL);

    pStr = new KrString("Frogs and jumping");
    pD1->Set_docnotesTitle(pStr);
    pDL->Append(pD1);

    pD1 = new Document;
    pStr = new KrString("Huckleberry Finn");
    pD1->Set_doctitle(pStr);
    pD1->Set_selectedItem(true);
    id = new KrString("D5");
    pD1->Set_id(id);

    pSL = new KrStringList;
    pStr = new KrString("humor");
    pSL->Append(pStr);
    pStr = new KrString("river");
    pSL->Append(pStr);
    pStr = new KrString("life");
    pSL->Append(pStr);
    pStr = new KrString("mississippi");
    pSL->Append(pStr);
    pD1->Set_keywords(pSL);

    pSL = new KrStringList;
    pStr = new KrString("How not to succeed while trying.");
    pD1->Set_docnotes(pSL);

    pStr = new KrString("Mississippi and life");
    pD1->Set_docnotesTitle(pStr);

    pDL->Append(pD1);
    pA1->Set_publishedWorks(pDL);

    pAL->Append(pA1);

    pA1 = new HumorFictionAuthor();
    id = new KrString("A3");
    pA1->Set_id(id);
    pA1->Set_topicArea(new KrString("Politics"));
    pA1->Set_name(new KrString("Molly Evins"));
    pSL = new KrStringList;
    pSL->Append(new KrString("Writes for progressive magazine"));
    pSL->Append(new KrString("Comes from Texas"));
    pA1->Set_authNotes(pSL);

    pDL = new DocumentList;

    pD1 = new Document();
    id = new KrString("D1");
    pD1->Set_id(id);
    pD1->Set_doctitle(new KrString("Molly Ivins can't say that can she"));
    pDL->Append(pD1);

    pD1 = new Document();
    id = new KrString("D2");
    pD1->Set_id(id);
    pD1->Set_doctitle(new KrString("Nothin' but good times ahead"));

    pDL->Append(pD1);

    pA1->Set_publishedWorks(pDL);
    pAL->Append(pA1);

    pA4 = new RomanticFictionAuthor();
    pA4->Set_topicArea(new KrString("Bodice rippers"));
    pA4->Set_name(new KrString("Daniel Steel"));
    pSL = new KrStringList;
    pSL->Append(new KrString("Exciting"));
    pSL->Append(new KrString("Erotic"));
    pA4->Set_authNotes(pSL);
    pA4->Set_period(new KrString("Eighteenth century"));
    pAL->Append(pA4);

    NonfictionAuthor * pA5 = new NonfictionAuthor();
    pA5->Set_name(new KrString("Robert Reich"));

    pSL = new KrStringList;
    pSL->Append(new KrString("Labor"));
    pSL->Append(new KrString("Economics"));
    pA5->Set_authNotes(pSL);

    pA5->Set_docCount(3);
    pAL->Append(pA5);
    
    pB1->Set_authors(pAL);

    return pB1;
} // buildkr

// ---------------------------------------------------------

void testkr(Bibliography * pB1, char * dbname, char * objname)
{

    cout << "(testkr) dbname: " << dbname << "  objname: " << objname << endl;

    // Decompile the bibliography.
    KrOstream ofs("test.krf");
//    InitializeDcplIdCounts();
    int count = 0;
    pB1->Decompile(ofs, 0, count);
    ofs.close();

    // Generate the .IPF file.
    KrOstream ofs1("test.ipf");
    pB1->GenIpf(ofs1, 0);
    ofs1.close();

    // Save the bibliography into the database.
    btOpenDb(dbname);

    // Add a couple of dummy records, so that we do not use recno=0.
//    Db::RecNumber junkrecno1 = btAddRec(pB1, sizeof(Bibliography));
//    Db::RecNumber junkrecno2 = btAddRec(pB1, sizeof(Bibliography));
//
//    cout << "junkrecno1: " << junkrecno1 << "  junkrecno2: " << junkrecno2 << endl;

    DbBlock * pBlk = new DbBlock;
    Db::RecNumber recno = pB1->Save(pBlk, Db::DB_NULL_RECID);
    Db::RecNumber recno1 = pBlk->FlushBlocks(recno);
    btAddKey(objname, recno1);
    btCloseDb();

} // testkr

// ---------------------------------------------------------

void loadkr(char * dbname, char * objname)
{
    btOpenDb(dbname);
    DbBlock * pBlk = new DbBlock;
    Db::RecNumber nextRecno;

    Db::RecNumber recno = btSearchKey(objname);
    if (recno == Db::DB_NULL_RECID)
    {
        cout << "*** Error.  Can't find key: " << objname << endl;
        return;
    } // if
    recno = pBlk->LoadBlocks(recno);


    Bibliography * pB = Bibliography::Load(pBlk, recno, nextRecno);
    if (pB == NULL)
    {
        return;
    } // if

    // Display a list of the names of all the authors in the bibliography.

    cout << endl << "Authors and Documents:" << endl;

    AuthorList * pAlist = pB->Get_authors();
    if (pAlist != NULL)
    {
        AuthorLink * pAlink = pAlist->GetFirst();
        while (pAlink != NULL)
        {
            Author * pA = pAlink->GetData();
            if (pA != NULL)
            {
                cout << "Author: " << (char *)*pA->Get_name() << endl;
                DocumentList * pDlist = pA->Get_publishedWorks();
                if (pDlist != NULL)
                {
                    DocumentLink * pDlink = pDlist->GetFirst();
                    while (pDlink != NULL)
                    {
                        Document * pD = pDlink->GetData();
                        if (pD != NULL)
                        {
                            cout << "    Document: " << (char *)*pD->Get_doctitle() << endl;
                        } // if
                        pDlink = pDlink->GetNext();
                    } // while
                } // if
            } // if
            pAlink = pAlink->GetNext();
        } // while
    } // if

    // Delete an item to test Delete from list.
    AuthorList * pAList = pB->Get_authors();
    Author * pA = (*pAList)[2];
    DocumentList * pDList = pA->Get_publishedWorks();
    pDList->Delete(1);

    pA = (*pAList)[1];
    pDList = pA->Get_publishedWorks();
    Document * pD = (*pDList)[0];
    KrStringList * pSList = pD->Get_keywords();
    cout << "docnotes[2]: " << (char *)(*(*pSList)[2]) << endl;
    cout << "docnotes[3]: " << (char *)(*(*pSList)[3]) << endl;
    pSList->Delete(3);
    cout << "docnotes[2]: " << (char *)(*(*pSList)[2]) << endl;

    // Decompile the bibliography.
    KrOstream ofs("test1.krf");
//    InitializeDcplIdCounts();
    int count = 0;
    pB->Decompile(ofs, 0, count);
    ofs.close();

    btCloseDb();
} // loadkr

// ---------------------------------------------------------

void KrReportError(char *msg, int level)
{
    switch (level)
    {
    case 1:
        cerr << msg << endl;
        break;
    case 2:
        cerr << msg << endl;
        break;
    case 3:
        cerr << msg << endl;
        break;
    case 4:
        cerr << msg << endl;
        break;
    default:
        cerr << "(KrReportError) Bad error level: " << level << endl;
        break;
    } // switch
} // KrReportError

// ---------------------------------------------------------


